===============
CHANGES: xxdiff
===============

Version 5.1
-----------

* Applied changes porting to Qt6 by Lior Silberman and tested on Ubuntu with
  g++-11.2 and clang-14. No feature changes.


Current Development Version
---------------------------

* Applied patch from Vadim Zhukov <persgray at gmail dot com> for more general
  local encoding conversion.

* Fixed coredump on long lines by allowing line length up to 2^32.
  (Thanks to Jim Diamond for finding the issue.)

Version 5.0b1: Port to Qt5 by Rene J.V. Bertin
----------------------------------------------

* Switch to Qt5 (tested with 5.6, probably ok with older versions too)
* Add keyboard shortcuts for "Save as left" and "Save as right"
* Prevent accidental wheel-zoom when pressing the Ctrl key while inertial scroll events are coming in.

Version 4.0.1: Port to Qt4 by Alexandre Feblot
----------------------------------------------

Just an update of the tarball with various bug fixes over 3 years.


Version 4.0b1: Port to Qt4 by Alexandre Feblot
----------------------------------------------

* Merged patch by John Schmerge (<john dot schmerge at gmail dot com>) to make
  build work with bison 2 and 3.

* Merged in Rene J.V. Bertin's port to Windows 7 (<rjvbertin at gmail dot com>).

* Alexandre Feblot submitted a port to Qt4 which also work on the
  Mac--did lots of work!--I made that the official default version. He
  can be reached at <alexandre dot feblot at gmail dot com>.

--- Changes ---

* Full Qt4 (.ui files in Qt4 format, no use of Qt3Support)
* GUI refresh to show a more modern look (frames, file labels, line numbers, cursor)
* Allow to click in the overview to jump to the chosen area (patch from Mark B. Thomas)
* When saving a file with unresolved conflicts, xxdiff now uses conflict markers
  which it is able to understand when unmerging. Those markers may be customized
  with resources Tag.Conflict.{Start,Sep,SepExtra,End} which replace
  Tag.Conflict.Separator. %L, %M, %R are replaced by left, middle and right files.
* Allow to clear search results by searching for an empty string
* Add instant search bar in the online user's manual
* Ability to double click the application on OSX to start it
* The diag and cross patterns in text widgets now horizontally scroll with the text.
* Remove unused resource 'Conditional.Else' (pattern is if/elseif/end)
* Remove useless --mac option (OSX uses usual unix newlines)
  and add the new Qt option --graphicssystem.
* Add a rule to create a distributable OSX package (.dmg) of an xxdiff bundle
  embedding Qt libraries (64bit only, 32bit part is removed) (make deploy)
* Some accelerator names may change, as xxdiff now uses standard Qt accelerator strings.
* Set the 'Macintosh (aqua)' style as a default on OSX.

--- Bugfix ---

* Merged views now scroll and relocate to the cursor line properly
* Resource 'ShowPaneMergedViewPercent' was not taken into account
* With Aqua style on OSX, the frame showing the current selected color in the
  color option tab was not visible
* Diffs are properly recomputed after a file edition
* Fix copy/pasting text on OSX
* Fix to build on Solaris 10, Sun Studio 12
* Fix (workaround) random crash in horizontal diffs computation
* When saving a file with unresolved conflicts using the conditional option,
  the last chunk was not managed properly.



Version 3.2.2: Minor features, closing Qt3 Version
--------------------------------------------------

* Fixed nasty old split-swap-join bug.
* In dirdiffs, if an insert, don't invoke a subdiff on directory + empty.
* Added Hanna Mousa Makefile for Sun AMD64
* Applied Bill Jones patches for RHEL/CentOS build.
* Applied H.Nestler's patch to documentation.



Version 3.2: (major feature enhancements)
-----------------------------------------
:Abstract:

  Implemented a Python package that contains much code to support writing
  scripts around xxdiff.  All the xxdiff-* scripts have been integrated in this
  Python package and renamed for convenience.  New features: a warning is now
  issued in decision when accepting or rejecting, if incompatible selections
  have been made.  The build system was converted from tmake to qmake.  Fixed a
  few minor bugs.


* In decision mode, if there are at least one selection from each side, if the
  user leaves with A or R, pop a confirmation box.  This is important to avoid
  errors.  It is way too easy to select for merge and exit with A.  I've been
  caught many times. (dup: In decision mode, we should warn the user when
  selections have been made and the user does not exit with "merged".)

* Applied patch from Henry Nestler for qt-3.0 compat.

* Applied changes from Trevor Harmon for Qt4 compilation.

* Added Trevor Harmon changes to add new feature --prompt-for-files for Mac OSX
  startup with file dialog asking the user what to diff.

* Applied Trevor Harmon's patch for xxdiff.pro for Mac OSX.

* Added a default binding for SaveAsMerged on Ctrl+M, after I saw the comment
  from the Monotone docs.

* Finally ported the build system from tmake to qmake!

* Caught error gracefully when xxdiff is missing in the user's path.

* Fixed xx-cvs-diff review/accept mode (still need to test it more).

* Changed the one-file input syntax from xx-cond-replace: You must now always
  pass two parameters.  If you want to get input from stdin, use - as the first
  argument.

* Ran pychecker and fixed a ton of little latent bugs.


(Version 3.2b4)

* **ATTENTION ATTENTION** Renamed all the xxdiff-* scripts to their equivalent
  xx-* scripts.  This is done to shorten the names, and to clearly mark the
  transition between the old and the new codebase.  I know it's evil, and I
  don't do this very often, but there is so much code that is on top of xxdiff
  being called by these scripts now, that to include the full xxdiff name in
  them does not make so much sense anymore.  They all leverage xxdiff, but they
  do so much more.  So there.  If you got annoyed by this, please send me email,
  otherwise I'll never know.

* xx-rename: we now support multiple lists of rename pairs in one run.

* Renamed cvs-revcomp to cvs-revcmp.

* Worked on xxdiff.el somewhat, not finished.

* Integrated code from Michalis Giannakidis (the cvsxxdiff.py author), so that
  cvsxxdiff.py is now xxdiff-cvs-revcmp.  Thanks!

* Applied bug fixes for xxdiff-cvs-diff from Michalis.

* Added documentation for xxdiff-sql-schema


(Version 3.2b3)

* xxdiff/invoke.py: refactored the xxdiff invocation functions to accept open
  files as stdin.

* xxdiff-svn-diff: Fixed bug with diff of directories crashing: we're not
  ignoring directories and symlinks appropriately.

* xxdiff-svn-diff: Implemented history for file review.  xxdiff-svn-diff
  remembers the list of files it has already viewed in previous sessions, as
  long as the list of pathnames (considered as absolute) are the same.  This
  information is saved, along with the merge comments in the user's
  $HOME/.xxdiff-svn-diff directory under an appropriate hash.

* xxdiff-svn-diff: Allowed an explicitly specified file (via --comments-file) to
  be recycled;  this is useful if you interrupted the preview process and you
  do not want to lose the comments you made.  By specifying the same filename,
  the file is not overwritten and its contents are thus recycled.

* xxdiff-svn-diff: Ignoring the specified comments file if it is within the
  Subversion directory that we want to diff.  So you can do this at the root of
  your checkout, and it works::

     xxdiff-svn-diff -cC .comments

* xxdiff-svn-diff: can optionally spawn a comments editor window and commit
  after review.  A nice process to commit to Subversion with this is this:

     xxdiff-svn-diff -fc

  This will:

  1. Run svn-foreign to handle unregistered files, if necessary
  2. Asynchronously spawn an editor window with the list of files to be
     reviewed, for you to write your merge comments while you review your
     changes with the xxdiffs in the background;
  3. Run the changes preview with xxdiffs
  4. Wait for you editor to terminate.
  5. Commit the changes to Subversion.


* xxdiff-svn-diff: can optionally run svn-foreign before the file preview (in
  the same process).

* svn-foreign: Added backups to svn-foreign, for deleted files.  svn-foreign can
  still be copied and used independently from the xxdiff library, and the
  backups feature is only available if the xxdiff libs are found.

* Moved svn-foreign into the xxdiff scripts packages, so that its functionality
  can be reused in-process.  (Note to packagers: feel free to install it or not
  along with the rest of the xxdiff-scripts.  When used by itself, it is not
  really tied to xxdiff but it is a really useful program.)


(Version 3.2b1)

* **IMPORTANT** This release focuses on a complete overhaul of the
  infrastructure for making Python scripts around xxdiff.  There is now a Python
  package that is to be distributed and installed with xxdiff, and all the
  scripts share code in there.  For the full juicy details, see::

      doc/xxdiff-scripts.html

  Note to packagers: you now have to include a Python distutils install in
  addition to the C++ xxdiff code.  This is done like this::

      (as root)#  python setup.py install

  All the Python scripts now depend on Python-2.4 or higher.


  * Completely rewrote all the Python scripts.

  * Fixed some bugs in the scripts.

  * Improved the way that backup files are saved.

  * Wrote global, general documentation about the scripts and removed the
    automatically-generated documentation.

    * Added an example about how to provide another transformer with xxdiff
      verification (in documentation)


  * Ported all old child process code (like popen) in the scripts to the
    subprocess module.

  * xxdiff-resolve: Created a new script that finds all the files that are still
    in conflict and invokes a 3-way merge algorithm to resolve them.

  * xxdiff-svn-diff: There is a new script ``xxdiff-svn-diff`` that can be used
    to view all the changes in a subversion checkout.  It drives the show
    itself, rather than being invoked by Subversion itself.  This has several
    advantages.

  * Add new options to selection code:

    - --select-grep: Among the files selected by filename, select only those
      which match the given regexp (or multiple clauses)

    - --ignore-grep: Among the files selected by filename, ignore those which
      match the given regexp (or multiple clauses)

  * Some (but few) of the short options have changed during the complete revamp
    of the Python scripts.  You should review your calling scripts if they use
    short option names.

  * Created xxdiff-rename, a script that allows one to perform global renames
    (this is similar in purpose to the most common use case for
    xxdiff-find-grep-sed).  Also: xxdiff-rename does not use external processes
    to perform the replacement, it's all done from within Python.  This should
    make it possible to run easily under Windows.

  * Created xxdiff-filter, a script that runs the transformation loop using a
    UNIX command filter (see docs).

  * Made an infrastructure to process files in transformation loops.
    xxdiff-find-grep-sed was rewritten in those terms.

  * xxdiff-diff-proxy: Included patch from Martin Renold <martinxyz@sf.net> for
    return code and ignoring stderr [1329298].

  * The xxdiff-subversion proxy script that is used to be invoked from ``svn
    diff`` has been renamed to ``xxdiff-diff-proxy``.

  * Created lib/python directory to hold shared code between all the Python
    tools, thereby reducing redundancy.  The price to pay for this is that you
    cannot simply copy the xxdiff-* scripts in a bin directory anymore, to run
    them, you must also install the xxdiff python library.  A setup.py file is
    provided for this purpose.

    I finally did this because the cost of redundant code was becoming annoying
    in the presence of my desire to code new tools.  I did not want to have to
    cut-n-paste anymore, in the name of having every script be self-contained.
    Installing a Python library is not such a big deal anyway, and I judge that
    there is enough code by now to warrant it.  In addition, this will make it
    possible for people that want to write their own scripts to reuse some of
    the infrastructure that I provide for the already existing scripts.

    Note to packagers: you should be able to install the xxdiff Python library in
    the most usual way for Python programs::

        (as root)#  python setup.py install

* Changes not related to the scripts:

  * Incorporated patch for building RPMs (untested, I don't have a RH box),
    submitted by Harshula <hash at jayasolutions dot cjb dot net>

  * Fixed pointer ownership bug that occurs on BSD, using user-submitted patch
    and review (Russell Cattelan - cattelan@sf.net) [1382170].

  * Applied user submitted patch (Robert Jackson - rjsweb@sf.net), which fixes
    the destination directory for file copy in directory diffs mode, to add the
    appropriate destination directory. [1210548]

  * Fixed line number in --single mode [1351955].

  * Applied user submitted patch (Wim Lewis - wiml@sf.net) for unescapeChars()
    bug [1094008].

  * When using --exit-on-same, output something if we're in decision mode.

  * Created ports subdirectory, added files for MAC OSX from Alexandre Feblot.

  * Added patch from Robin Humble for building x86_64 rpm.

  * WARNING!!!  Some of the switches have changed, in the name of consistency.
    You will need to review your scripts.


Version 3.1: (minor feature enhancements)
-----------------------------------------

* Implemented feature to save to temporary files before running subordinate
  diff.  This is useful if you want to support reading from FIFOs. [ 538340 ]
* Made font widget string correspond to qt3's conversion system.
* Changed default gen init file to $HOME/.xxdiffrc and moved this to Save
  Options under File Menu (everyone was puzzled by the UNIX way of doing things,
  so I give in).
* Removed unused code.
* Rewrote code to render text to render carriage returns explicitly.
* Removed debug drawing in text widget that was showing up only in debug mode.
* Added documentation on selecting individual lines [ 649285 ].
* Added --show-merged-pane option (ericveum suggestion) [ 867395 ].
* Changed the options help a little bit and added display options.
* Removed forgotten cerr output in util.cpp.
* Implemented interactive font resizing [ 964629 ].
* Simplified wheel redirect code.
* Updated documentation ([ 1011009 ] Tomas Pospisek)
* Added wheel support in overview area ([ 1022392 ])
  Thanks to Brett Levin for the patch.
* Fixed xxdiff-cond-replace with zero arguments.


Version 3.0.4: (minor bug fixes)
--------------------------------

* Fixed crash for redo diff [ 1061364 ].


Version 3.0.3: (minor bug fixes)
--------------------------------

* Fixed [ 571454 ] memory leak when running on /proc/$$/status files.
* Fixed [ 566683 ] backslashes stay in resource strings.
* Fixed leftover problem with UI not being created.
* Add simple subversion script from saqib.rasul
* Implemented redirect of wheel events from text widget to scrollbar.
* Implemented rendering of horizontal insert markers (1 pixel wide). We still
  need to add the option to the dialog box, but it is available from the display
  menu.
* Made a slight improvement to horizontal diffs that attempts to correct over
  the change hunks that the dynamic programming heuristics algorithm comes up
  with.
* Fixed bug with uninitialized variable in overview area [ 894724 ].
* Added bug fix from Francois L'Archeveque for horizontal diffs, bug that would
  occur in rare cases and that would calculate a larger diff rather than less;
* Added optcomplete support to xxdiff-* scripts.
* Changed xxdiff-cond-replace to accept a file on stdin.
* Creation of xxdiff-cond-replace script and documentation.
* Improvements in xxdiff-find-grep-sed, backing up files only when needed.
* xxdiff-find-grep-sed and xxdiff-cond-replace ClearCase checkout only when
  absolutely needed (untested, I don't have ClearCase at the moment).

Version 3.0.2: (minor bug fixes)
--------------------------------

* Fixed important bug with reloading files after they have been saved.  Load two
  files with diffs, select various hunks, save files, reload diff.  It will
  sometimes crash.  The problem was that the fileinfo structure was being
  recycled and it cannot.

* Removed old ifdef'ed code from builderFiles2.
* Changed how the versioning is done, there is a single file in the root that
  contains the version number now.
* Moved version.{h,cpp} to proginfo.{h,cpp}
* Removed dependency of some old scripts on obsolete parse_opts home-grown
  module.
* Converted xxcvs.newer to optparse, but I don't use it, no tests yet.
* Added useful --select-files option to xxdiff-find-grep-sed.  There is enough
  interesting behaviour in the grep-sed part of the script for this to be
  worthwhile.

Version 3.0.1: (minor bug fixes)
--------------------------------

* Factored out the toTime_t problem, fixed other problems with qt2.
* Applied patch from Oron Peled <oron at actcom.co.il> for missing toTime_t
  under qt-3.0 (and not just qt-2.x as I was thinking).  This should make it
  work under RedHat-8.0.
* Made xxdiff-find-grep-sed run diff again on merged decision, to reflect in the
  output log what lines actually have been merged.


Version 3.0: (minor features and stability release)
---------------------------------------------------

This releases marks a long period of stability with relatively few and isolated
bugs.  We have implemented a few minor features and have decided to release as
3.0 to make this the new stable version.

* Fixed some cmdline options documentations.
* Wrote new documents in xxdiff/doc and added links.
* Tested xxdiff AMR with 3 files, it works, logic is a bit illogic w.r.t. "mine
  oler yours" order (but it makes sense w.r.t. "yours older mine" ordering).  I
  would rather be consistent with the left <-> right behaviour with 2 files.
* Added Makefile and HTML documentation for scripts.
* Added GNU copyright text to all python scripts in xxdiff/bin
* Never ask about overwrite when saving to the merged file if a --merged-file
  option has been specified: after all, if the user (or script) has specified it
  on the cmdline, it's expecting that file to be overwritten.  Removes the
  annoying warning when running from scripts that require saving to the merged
  file, in that case (and it makes sense).
* Refactored code to ask about file overwrite.
* Added --recipient option to xxdiff-encrypted for people who have not
  configured their gpg (this might help).
* Finished and tested xxdiff-encrypted.
* Added an extra line between options in 'xxdiff --help' output for aeration.
* Added indicate-input-processed feature for xxdiff-encrypted.
* Added a few simple switches where it made sense.
* Removed useless printInvocation function.
* Removed XX_ENABLE_FORCE_SAVE_MERGED_FILE obsolete code.
* Worked on scripts, xxdiff-encrypted.
* Added compiler.h compiler detection, using current defines from Boost CVS
  (2004-01-14)
* Removed having to set the compiler in the makefile with xxdiff.pro
* Added info to build on RedHat AS w/ qt2.
* Added moc_app.cpp file that will work with qt2.
* Couldn't find how to get qt2's moc to act correctly about the XxApp base
  class.  This generates an annoying warning with qt2. Will tolerate.
* Back-ported to qt2
* Applied patch from [ 867279 ] "sun compile issue: C/C++ lib getopt prototype"
  from <ericveum at oracle.com>.  Fixed SUNWspro build problem.
* Applied patch from [ 867274 ] from <ericveum at oracle.com>.  Fixes SUNWspro
  build problem.
* Created xxdiff/bin and added some xxdiff-cvs scripts in there.
* Changed Makefile target to create xxdiff in xxdiff/bin instead.
* Added projects env init file so that I don't have to fiddle now when I want to
  use debug xxdiff.
* Fixed this bug from my TODO file:

  "xxdiff --unmerge <file>" (and not unmerge3) crashes with floating
  point exception on this file contents:

        <<<<<<< A
        lines from A
        ||||||| B
        lines from B
        =======
        lines from C
        >>>>>>> C

* Implemented xxdiff/tools/misc/xxdiff-match for bug reporter [480106].
* Fixed bug [607560] with saving files when using --unmerge and --unmerge3.
* Chased bug with [820781] with problem using --mac under Linux, because GNU
  diff doesn't understand mac newlines.  So I clarified the --mac option
  documentation a bit.
* Applied change for setting locale internally because we parse only english
  messages.
* Added function and toolbar button: next and diff files.
* Made new pixmaps for the diff files at cursor button.
* Found problem with exclude option, it was so simple, why didn't I bother
  before now!  Enabled support for --exclude and --exclude-from directly from
  xxdiff command-line.  You can now ignore those CVS and ``*.o`` files in your
  directrory diffs!
* Changed documentation source from qml to docutils text file (to be converted
  manually with docutils-html tool every time). At least I don't have to write
  HTML by hand anymore. Simple is best. Me like simple solutions.
* Updated documentation for new features.
* Removed --output-on-exit option and replaced it with --decision option,
  which replaces the normal exit hook with three hooks, so you're force to
  exit with a decision of accept, merged (with merged file) or reject.
  There are default (overrideable) bindings for the decisions on 8, 9, 0.
* Implemented ACCEPT, MERGED, REJECT toolbar buttons for better integration
  with interactive patch merging. You can use the string output by xxdiff
  upon exiting to implement the desired replacement.  The MERGED button
  forces a merge output to be present.  Not sure if this is generic enough,
  but I think it is.
* Applied patch from Eric Veum <eric.veum at oracle.com> for Clearcase return
  status.
* Applied patches from Georg Baum <Georg.Baum at post.rwth-aachen.de> for
  switch from rawname to toString/fromString.
* Incorporated patch for format strings in user-provided titles by
  Tommi Kyntola <tkyntola at cc.hut.fi>
* Added SaveAsMerged binding.
* Added Christian Fowler <cfowler at lulu dot com> tools for Perforce.
* Re-organized scripts/ and tools/ directories.
* Added comment about compiling with .NET from bug report.


Version 2.9.2: (minor features)
-------------------------------

* Removed unimplemented exclude switches.

* Tested build with qt-3.1.1, it works fine.

* Incorporated fix for "--help-html" crash when compiled against KDE (thanks
  to Andreas Pour <pour at mieterra.com>).

* Added tentative option for attempting to process Macintosh files with CR as
  line terminator.

* Added special marker in counter for remaining unselected regions that would
  mark when the two files are equal byte for byte; This allows the developer
  to visualize quickly if the file has no difference if at least it contains
  whitespace differences.

* Implemented "--single" option to allow xxdiff to open a single file.

* Double-clicking on an added or removed file in directories mode now
  opens an xxdiff with a single file in it. This is to be used for
  convenience. You'd be better off using a file editor to visualize
  single files, but some people like the consistency of looking at
  everything thru the same program.


Version 2.9.1: (minor bug fixes)
--------------------------------

* It hadn't occurred to me that most people use the Alt key as their window
  manager key in sawfish or the kde winmgr (I use the Super key bound in the
  lower left control to free my Alt key). Thus my choice of Alt+Button1 for
  the variable text selection will not work with most people's default
  configurations.

  So I have decided to change it, nasty me, to Control+Button1. I moved the
  NEITHER selection that was bound there to Shift+Button3.


Version 2.9: (minor features)
------------------------------

* Implemented variable text selection in text widget.
  Press ALT-Button1 and drag to select text that gets put in the
  clipboard.

* Split formatting into header formatting for the whole selection text and
  per-line formatting.


Version 2.8: (minor bug fixes)
------------------------------

* Implemented per-hunk ignore whitespace for 3-way diffs properly (fixed
  problem described in 2.7.2).

* Enabled forgotten disabled ignore-blank-lines menu item.
* Removed now unused libgen.h from app.cpp (thanks to dmarks @ sf for
  reporting the bug).
* Applied changes from JF Panisset for SGI/IRIX/MIPSPro * compilation.


Version 2.7.2: (minor bug fixes)
--------------------------------

Known Issue With 2.7.2: 3-way diffs will break if you turn on the per-hunk
ignore whitespace feature. This warrants 2.8 release.

* Removed forgotten debug trace.


Version 2.7.1: (minor bug fixes)
--------------------------------

* Fixed minor color bug with rendering per-hunk ignore whitespace with
  directory diffs.


Version 2.7: (minor features)
------------------------------

This release introduces a very useful feature for merge reviewers: diff hunks
which contain only whitespace and line break changes will be detected and can
optionally be flagged with a different color. This permits the reviewer to
quickly ignore source code reidentation and reorganization changes.
Also, alignment lines are now be filled in with a subtle pattern to better
identity them (can be disabled).

(Misc)

* Blank lines can now have a little cross-pattern drawn in them, to better
  identify visually that they are not real file lines, but rather just
  inserted for display purposes. This makes it dead obvious. Most won't care.
* Made little pattern on by default.

(Per-hunk Ignore Whitespace)

* Implemented the per-hunk ignore whitespace feature for two-way and
  three-way diffs.


Version 2.6: (major features and minor bug fixes)
-------------------------------------------------

This release finally introduces support for the ignore-blank-lines feature of
GNU diff, as well a new feature to force the production of merged files if
desired. The port to Qt-3 has been completed and xxdiff can now be compiled
conditionally with KDE support (thanks to Trevor Harmon). Many minor bug fixes
are included as well.

Important note: qt3 is now required. 2.6 will not compile with qt2, due to
differences in the UI designer files between qt versions. Such is life.

(Per-hunk Ignore Whitespace)

* Implemented of the ignore-display feature in preparation for per-hunk
  ignore feature.

(Style Resource)

* Add a new resource: Style, so that users can specify the tooklit style via
  .xxdiffrc.  Cmdline specification of style still takes precedence.

(Force merged file production)

* Moved markersFileDialog.* to markers.*
* When using --output-on-exit, don't bother the user about overwriting
  existing files for the merged output file for Perforce users (thx to Philip
  Quiney <phil.quiney at radiantnetworks.co.uk>
* Made sure that closing window should invoke the last hooks and remains in
  the application, and closing subsequent windows, with --output-on-exit the
  user is really forced to save a file.
* Introduced XxMarkersDialog, a dialog that contains just the markers, and
  not the file dialog either. This one is used for --output-on-exit and could
  eventually be used in the save as left/middle/right/merged dialogs, if I
  didn't want the convenience of being able to change the name right there.
* Finished implementing feature to force the user to produce a merged file.

(Tools)

* Added emacs editing settings somewhere in the tools subdir for contributors
  to peruse.

(KDE Port)

* Fixed KDE color dialog bug, when canceling color it was getting set anyway.
* Modified KDE code slightly.
* Applied KDE patch contributed by Trevor Harmon <trevor at vocaro.com>.

(Ignore Blank Lines)

* Enabled the options dialog option for ignore blank lines.
* Implemented working heuristic to match lines when ignore-blank-lines is
  on. We check for empty lines that try to match the non-empty lines. I'm
  pretty convinced that this should work in all cases, but although all my
  tests seem to work, I will validate this over the next few weeks and only
  release if all goes well. This should conclude the long-waited support for
  ignore-blank-lines, which improves considerably the quality of diff output
  in many cases.
* Implemented display of ignored blank lines in SAME regions. This pretty
  much makes it work.  I'll have to do some more testing before I release.
* Started experimenting with diff output parser support for ignore blank
  lines. It works, but I want to make it somehow display the blank lines
  (just not as a diff).
* Re-enabled tentatively ignore-blank-lines option to start testing it how we
  could support it.

(Text Rendering Bug)

* Reverted to drawing the background rectangle color by hand.
* Looked at it, added some debugging code.

(Misc)

* Fixed bug with geometry parsing [566678] [566682].
* Fixed typo in documentation [566684]
* Fixed bug with copy file expansion by quoting files
* Fixed bug with overview area not updating its vertical extents on redo diff.
  [533659] "rediff:no length update in overview area"
* Investigated false-assert reported bug about saving as merge conflicts.
* Removed using Id and Date in file headers... it makes diffs for nothing.
* Fixed clipboard bug that now occured with qt3, we put the selection into
  the "mouse", whatever that means.
* Fixed bug with not running exit hooks when closing through winmgr.
* Added DTD header for HTML output and validated HTML output of documentation
  using wdg validator.

(Pane Merged View)

* Started investigating vertical scrollbar problem with paned merged
  view. We'll need a pixel scrollbar I think.

(Port to Qt-3.0)

* Font rendering has finally all been fixed.
* Fixed default font, but I'm not able to get the same with the Qt way of
  specifying fonts.
* Text font label went really large with funny font description in options
  dialog, with certain fonts only. Bug fixed by Trevor Harmon.
* Fixed missing include file for Qregexp.
* Fixed overview area layout fixed size.


Version 2.5: (major features)
------------------------------

This release removes the saving of standard input into temporary files and adds
support for unmerging merge conflicts into three files (if the conflicts contain
the information, such as when using "diff3 -m").

(No Temporary Files)

* Removed saving of stdin to a temporary file. This could be considered is a
  major security update, because if you were using decrypted files to
  standard input of xxdiff. xxdiff used to save its stdin into a temporary
  file for redoing diffs. For example, running something like
  "gpg -d secret.asc | xxdiff - public.asc" would save a decrypted copy of
  secret into /var/tmp. Kill xxdiff and it would lie there. Now that's
  fixed.
* When a file is from stdin, redo-diff clears xxdiffs, that was
  crashing. With the new changes that don't save to a temporary file, that
  fixes the problem.

(CVS unmerge conflicts)

* Updated documentation for unmerge3 feature.
* Finished implementation of unmerge3 feature. We won't try to insert
  interrupted regions for the unmerge 3-files version, just insert SAME
  regions then (including markers).
* Finished first implementation of unmerge3 feature.
* Started implementation of parser for "diff3 --show-all" merge conflicts.
* Disabled more useless UI in unmerge mode.

(Misc)

* Slight improvement to goto file feature, fixed bug with goto-line in
  unmerge mode.



Version 2.4: (major feature)
------------------------------

This release introduces the unmerge feature.

(CVS unmerge conflicts)

* Fixed newly introduced bug found with regression tests.
* Fixed display of unmerge line numbers in filename bar.
* Fixed unmerge display line numbers through better method (the file buffer
  contains the indirection line numbers, simple, less storage, and as
  efficient).
* Started fixing split/swap/join with display line numbers.
* Wrote documentation for unmerge.
* Tags for unmerge are now configurable through the resources.
* Fixed redo diff in unmerge mode.
* Implemented display line no support for line nos different than the real
  numbers, in XxLine.
* Fixed the overview area drawing problem by reindexing the buffers.
* Polished it up, and decided not to support arbitrary format through input,
  until QRegExp supports grouping expressions (known to be in qt3).
* Got it working! Now have figure out some small issues and polish.
* Resumed work on unmerge feature.

(Packaging)

* Enabled building rpms as user, not root.
* Added GPG signing of packages.

(Cleanup)

* Added dummy to diffs lines to make the lines access a tad little tiny bit
  faster.

(Misc)

* Make optimization in XxDiffs to avoid having to subtract 1 from lines
  array.
* Updated web page for 2.4.
* Fixed unimportant memory bugs in cmdline parsing.
* Fixed bug with scrollbars not adjusting properly to redo diff.  This bug is
  not present in the stable tree.  Kudos to Gijsbert De Haan for finding this
  one.

(Windows port)

* Finished compiling and linking under W2K. However, it doesn't run, we
  have a weird problem with getenv() causing an Access Violation, and when
  getenv is removed, we get an Access Violation inside Qt.
* More porting to Windows. It almost all compiles now.


Version 2.3: (minor features and major bug fixes)
-------------------------------------------------

(Quick save merged results)

* Partially implemented feature to force the user to produce a merged file
  and then ifdef'ed out, this will come later.
* Finished implementing feature, new resource to define default merged
  filename format.
* Changed default filename for "save as..." to be the merged filename.
* Implemented exit-if-no-conflicts feature.
* Changed implementation of select merge to use the resource system so that
  someone could set automatic merging to always be enabled if they wanted to.
* Started implementation of the force-saved-merged feature.

(Port to Gcc-3.0)

* Compiled with gcc3.1 (did not link).
* Linked with qt-2.3.2 compiled with gcc3 and it works.
* Ported all objects to compile with gcc-3.0.2.

(Documentation)

* Updated documentation to merged features.

(Misc)

* Some changes for HP/UX compilation (thanks to Albert Chin-A-Young)
* Fixed bug in color dialog; pressing cancel would set the color to
  blank. Credits to <volker_apelt at yahoo dot de> for reporting it.
* Fixed Debian compilation warnings reported by Tomas Pospisek
  <tpo at sourcepole dot ch>.
* Fixed implementation on EXIT_ON_SAME to really not show the window at all.
* Fixed bug with EXIT_ON_SAME and IGNORE_BLANK_LINES being turned on.
* Fixed important bug with not being able to grok files with spaces in
  them. This was also happening for spawning subdiffs from directory diffs
  (logged in as bug [508429].
* Added warning and disabled init option to ignore blank lines, because we
  cannot support it for now.
* Fixed bug with not parsing incomplete lines (kudos go to Greg Lonnon
  <glonnon at ridgerun dot com> for reporting it!)

(Install and Packaging)

* Added HTML file generation and packaging.


Version 2.2: (interim release)
------------------------------

This is an interim release because it contains many important bug fixes, but
also contains remaining bugs. However, the author is way too busy to finish it
properly and won't be able to in the next few weeks, so here is an interim
release. I won't announce it on freshmeat.


(Remaining unselected regions indicator)

* Implemented indicator for "remaining unselected regions" counter label
  (above the overview area).


(Split app and text widgets)

* Let the text view manage its own top and bottom line, as well as scrolling.
* Made the merged window use a normal text widget.  Not done.
* Finally cleaned up the whole update mess.  Big changes.
* Removed stupid scrolling menu entries.
* Finished basic not-clean splitting to central widget.
* Did est.50% of it, still needs to clean up app, broke
  everything in the meantime, but there are ifdefs (untried).

(Quick save merged results)

* Added UI for "save as merged" feature (not implemented yet).


(Merge)

* Implemented 2-way automatic merge selection (new feature).

(Misc)

* Fixed compilation to work with aix-xlc configuration, thanks to
  instructions from mark.truman@gtech.com.
* Fixed bug introduced in 2.1 with line copy exhibited with split/swap/join.
* Fixed bug introduced in 2.1 [485741]: insert at beginning of a line would
  display erroneous horizontal diff (thanks belley).
* Fixed bug: the pane merged view didn't always update right.
* Added conditionals for all delete[] (i had forgotten).
* Changed Command.Edit default value to an xterm instead of just a vi.
* Makefile now cleans doc.h.
* Added man page from Tomas Pospisek, changed spec files to install it.
* Debian package for 2.0.2 has just been made by Tomas.
* Remove all FIXMEs and change for something else.
  We should be able to grep for no FIXMEs in the code before releasing.

(Pane Merged View)

* Made scrolling work in pane merged view.
* Fixed minor bug when deleted region is rendered on alignment lines in
  merged rendering.
* Finished integrating merged view rendering and text rendering in the same
  code.
* Bug: the merged view vscroll is not adjusted like the text one.
  New shared design fixes this.
* Draw the highlights even in the merged view, it will really help figure out
  which side has been chosen.
* Worked more on polyvalent text rendering widget, almost done.
* Added sup color for decided merge regions: the merged view will now render
  with horizontal diffs as well.
* Figured out how to build a rpm as non-root, what options to use.
  ~/.rpmmacros : %_topdir   ~/tmp/rpmbuild, %_tmppath  /var/tmp
* Merged changes from 2.0.3.
* Fixed bug: using splitter, resize text view to zero, and you would get an
  internal error at (diffs.inline.h:46).
* Fixed automatic adjustment of splitter percent for merged view.
* Tested pane merged view toggle and checkbox update.
* Tested popup merged view toggle and checkbox update.
* Fixed bug with pane merged view, continued implementation.
* Implemented popup merged view upon startup.
* Implemented new layout with pane merged view.
* Added show resources for pane and popup merged view.
* Added percent resource for pane merged view.
* Decided on names for different merged view: pane m.v. and popup m.v.

* Add an option to make layout the merged view like xcleardiff, added an
  option to make it visible on startup as well.




Version 2.1: (major feature release)
------------------------------------

Implemented multiple horizontal diffs feature.  Rewrote ignore horizontal
whitespace feature to ignore changes in whitespace.  Added support for
command-line Qt options and formatted like KDE programs.

(Multiple horizontal diffs)

* Cleaned up code for multiple horizontall diffs.

* Made sure that the hordiffs don't get copied when the third file is empty.

* Optimized computation of horizontal 3-way diffs, when we know two sides are
  equal, don't compute bounds with the three files. Compute with two and copy
  other the third one, like we do for multiple diffs with blue regions.
  For DIFFDEL regions.  I rewrote the code that's driving this.

* Split hordiff code into its own file.

* Changed MinContext to Context.  This makes sense, there is a direct
  analogy.

* Fixed bug in insertion of ws inside a word, with more than 1 ws.

* Make the ignore horizontal whitespace treat all contiguous chunks of
  whitespace as a single whitespace (tdemarge idea).
  Implemented ignore horizontal whitespace as ws compression
  (this is a big difference and should be mentioned in the change log).

* Realized there is a problem with the implementation of the ignore
  whitespace approach that I used for horizontal diffs... whitespace cannot
  really be ignore when computing the diffs themselves, otherwise it can
  result in funny diffs, e.g. "word other" an "wordo other" will result in
  the second o being computed as a diff.  In this case there are many
  potential solutions, and it is not obvious which one we should follow.

  Another possibility would be to non-whitespace bracket the normally
  resulting diffs (taking into account ws), but then do we keep diffing
  recursively?

  We have the same problem with the single bracketing technique!
  This will require some thinking.

  (This was fixed above.)

* Implemented using permutations in line bracketing algorithm.
* Fixed nasty bug in multiple diffs horizontal table.
* Renamed hysteresis to min.context, because there is a direct analogy for
  horizontal diffs minimum common region to context lines in context
  (vertical) diffs.

* Implemented ignore whitespace support for multiple horizontal diffs
  (a simple bug remains
* Tested for when the maximum table size is exceeded... it works.
* Added resource parsing.
* Tested menu
* When changing the horizontal diff parameters in the resources, we have to
  invalidate and perhaps recompute the horizontal diffs.
* Implemented in 3-way, with blue regions, and diffdel as well.
* Compute and implement upper bound for hordiffs buffer, use in text and
  line.
* Much progress in multiple horizontal diffs implementation.
* Time was being wasted in horizontal diffs computatino for SAME lines, now
  removed that!
* Finished implementation of per-line computation of horizontal diffs with
  hysteresis.
* Implement string edit dyn.prog. solution for lcs for multiple horizontal
  diffs, per-character and per-token
* Implemented line and text area support for multiple horizontal diffs
* Added resources for horizontal diffs.
* Finished implementation of multiple horizontal diffs drawing.
* Prepared XxLine for multiple horizontal diffs.

(CVS unmerge conflicts)

* Started implementing cmdline parsing of conflict mode.
* Added builderConflicts files.

(Qt Options)

* Add --textfont cmdline option enable setting the text font as well.
* Remove usage message for errors.  Usage should only be printed out
  from --help or when no file has been specified on the cmdline.
* On --help, print out long options first, so all is aligned.
* Implemented options KDE-like.
* Looked at all the qt options that the KDE code exposes, and perhaps export
  the same set.  Look at how it's implemented under as well.
* Changed filename labels to use current app font, not resources font, in
  case of an override.
* Removed forcing the font is there's a qt -fn or -font option on cmdline.
* Added forceFont detection for cmdline.
* Tested --qt, perhaps rename to --qt-visual, etc.
* Within the qt options, you'd have to test for the presence of -style or
  -geometry as well.
* Fixed bug in new --qt cmdline arg.
* Changed semantics of XxCmdline._forceStyle.
* Made Qt options supported through explicit parsing of the GNU form of
  options.  This should fix the bug whereby the Qt options are not available
  anymore.

(Init switch)

* Implemented flawed initswitch for quality.
* Added Nop parsing to initswitch, so that reading from resoruce list is
  possible.
* Finished implementing initswitch feature.
  Of course, this is not super useful, but someone requested it.
* Added InitSwitch resource parsing (for belley) but not implemented
  initialiazation yet.

(Misc)

* Cleaned up and organized TODO file.
* Changed error when getopt fails, now returns the short error msg.
* Version should be the compiling date, and the file that contains the
  version number should always be recompiled, each time we link.  Figure out
  something. The current scheme doesn't quite work too well, unless version.o
  is from a make clean.

* Fixed bug with table width in documentation.
* Fixed minor bug with 3-way diffs options
  (imho this alone does not warrant a 2.0.3 release).
* Removed libgen, now using Qt's framework for basename.
* Did some stuff to the versioning, added version.c.
* Checked that a .inline.h change doesn't seem causes recompiling.
  There is a small delay probably due to NFS on different OS+hosts.
* Removed basename dependency (now using QFileInfo).
* Fixed UMRs in app.cpp menu items, Purified completely.


Version 2.0.4: (bug-fix release)
--------------------------------

We want the 2.0 branch to be absolutely stable, and not being able to parse
rarely occuring incomplete lines is unacceptable, so this bug fix alone warrants
this release.

(Bug Fixes)

* Included bug fix for not parsing incomplete lines. The incomplete line
  marker line inserted by diff had been overlooked in the parser and would
  cause an error dialog and no diffs display. Incomplete lines don't occur
  often, but this is nevertheless an important bug.



Version 2.0.3: (portability release)
------------------------------------

This release includes very minor changes for backwards portability to
Redhat-6.2, as well as a minor enhancement to allow the Debian package to have
its documentation automatically generated (--html-help doesn't require a display
connection anymore).

(Better automated packaging)

* --html-help now does not require a display connection, so that the
    packaging scripts can generate the documentation from the executable on a
    machine without display connection access (suggestion of Tomas Pospisek).

(Redhat-6.2 Portability)

* Make sure we can now compile under rh-6.2 (thx to Fabrice Crestois).
* Removed std::auto_ptr<>::reset().
* Small iterator change in diffs.cpp for rh-6.2 compilation.

(Misc)

* Removed circular dependendy in resParser.lex.c, this was due to the fact
  that by default make considers a lex file to have .l suffix and not .lex.
  We could patch it with a simple rule, but instead we rename the file to
  use the standard suffix.


Version 2.0.2: (bug-fix release)
--------------------------------

* Fixed bug with inserts and deletes having one char shaved off the end of
  the filename.
* Fixed bug with hanging  xxdiff when diffing large dirs.
  Error collection was being done before output collection.
* Fixed bug with segfault with more than 3 filenames specified on the cmdline
  (thanks to Trinh Ma for reporting it).

Version 2.0.1: (bug-fix release)
--------------------------------

* Tested all cases under IRIX.
* Fixed bug with saving conflict regions, needed to use a QByteArray.
  This was introduced following the removal of std::stream's.
* Fixed bug with tags when saving with conflicts.
* Found bug with saving conflict regions.  Of course, Murphy hits right
  after a major release.  Damn it.  I'll release a bug-fix release.

Version 2.0: (stable release)
-----------------------------

Changes since 1.13:  the focus of this release is an internal rewrite for
stability, portability and code sanity before embarking on a series of new
features.  There are not many user-visible changes, but you should switch
anyway, for stability.

   Summary of changes since 1.13:

   * ALL logged bugs have been fixed, including some nasty ones.  xxdiff is
     now more stable than ever, has been purified.

   * Removed internal dependency on std::string, we are now using QString
     everywhere internally.  Much less STL dependency now.  This should
     improve portability considerably (it was ported again to Solaris).

   * The resources system was rewritten completely, including the parser,
     which now defines its own little resources language.  Parsing the
     resources file should be much more efficient that it was.  The resources
     file format has changed.  Also, by default xxdiff will now turn on its
     cool unique features as they appear.  The output of --list-resources
     should now be parsable directly.  Xrm resources support has been
     removed.

   * User-visible changes: toolbar buttons have been reorganized slightly and
     bitmap are now nice and final.  Color legend is now integrated in the
     options dialog.  You can now customize fonts from the options dialog.
     The options dialog has been reorganized.  You can now maximized the
     geometry from the resources.  Cheesy logo added.  Error messages are now
     better.

   * Full documentation is now included with xxdiff and will be online.

   * Commands that don't require the display don't attempt to open a display
     connection anymore.

   * Build system has changed, we are now using tmake.

   * The text area rendering code has been rewritten entirely.  Rendering
     very very long lines should now work correctly.

   * The code was prepared for an upcoming Windows port tentative.


* Fixed bug with version printing missing endl in release mode.

Version 1.16: (pre-release)
---------------------------

* Setup trivial regression test script (gotta start this eventually).
* Updated root README file instructions.
* Updated all /tools dir.
* Added documentation table of contents.
* Fixed output of resources into HTML with HTML-able tags (XxHelp::xmlize()).
* Removed all stat() calls, replaced by QFileInfo.
* Removed useless XxUtil::isDirectory() code bloat.
* Fixed new bug with QTextStream going out of scope with a closed (f)stream.
* Used mpatrol and -check-memory-? to try to locate the problem with short
  filenames and setting accelerator 0.
* Purified xxdiff on IRIX.  It's clean.  Qt has lots of UMRs though, but no
  leaks.  This did not turn out the problem we see under Linux.
* Updated the spec files.
* Fixed rpm packaging for tmake, fixed distribution script.
* Implemented double-click feature for directory diffs for version 2.0
  (thanks to sourceforge user sgaskins).
* Closed all remaining bugs
* Fixed for Solaris 2.8 compilation.  It works!
* Updated getopt versions.
* Addressed changes for Solaris 2.8 compilation.
* Checked if xxdiff can indeed handle one DOS file vs. one UNIX file
  =-> add a FAQ section in doc and put this answer there
  thx to yves@dastous.org
* Reversed search fwd and bwd buttons (they're now like the others).
* Fixed bug in toggling recursive dir diff from options dialog.
* Fixed bug in toggling ignore file changes in dir diff options dialog.
* Rewrote documentation entirely.
* Implemented resources ref. output in documentation.
* Removed dumpUsage and change by the contents of man.h as well.
* Added html-help command, will finish implementation tomorrow.
* Using rich text for help, write single help file source in richetxt (qml).
* Figured out something for documentation.
* Generated usage in both formatted plain text and qml as well.
* Changed man transformation into a single big string.
* Wrote self-documenting cmdline options system.
* Added xxdiff_translate_resources script to tools.
* Moved archive in its own CVS module and renamed xxdiff-doc xxdiff-web.
* Added HTML documentation, still need to finish and polish it.
* Removed linking to internal diffs linkage before release
  (internal diffs to be done af ter 2.0).
* Changed tmake spec so we don't have to specify xxdiff.t
* Fixed bug with horizontal resizing on font change.
* Fixed diff3 parsing which had just been broken.
* Fixed non-thread-safe searchLine method (implement strnstr).
* Horizontal optimization of the text drawing (lots of optim.).
  Still not sure if it ends up being faster.
* More work on optimizing text drawing (horizontal characters).
* Fixed drawing bugs with text.cpp.
* Removed BUFSIZ in diff output parsing.
* Major optimization to text widget: text drawing should be much faster now.
* Finished documenting resources
* Re-ordered colors.
* reviewed contents of app.h and resources.h and recategorize app.h stuff.
* Turned on some xxdiff goodies by default, so we added a --orig-xxdiff
  cmdline switch for the romantics.  By default, xxdiff should enable the
  cool features it has.
* change permissions checking to use QFileInfo instead of access and friends.
* util.cpp: implemented one spawn in terms of the other
* Removed show_markers feature which was never implemented (and probably
  never will be).
* Added documentation.
* Cleaned up requirement for display connection in XxCmdline::listResources.
* Disabled edit button for widgets for which it is irrelevant.
* Made sure we don't require X connection to parse resources or cmdline args,
  except for those requiring it (i.e. --list-resources, for color and font
  conversions).
* Fixed terrible bug where the silent msg handler would remove Qt warning
  about not being able to connect to the display.
  Removed the silent msg suppressor thingy, we don't need it anymore.
* Made sure the pangrams are different in options dialog.
* For gen.init.file, we now check for empty file before saving.
* Added BOOLKWD_BASE constant token.
* Fixed bug with listResources, and moved to Qt streams.
* Fixed bug with gen.init.file.  If you start xxdiff and just gen.init.file
  directly, you should output an empty file.
* Finally finished nice bitmaps for toolbar buttons.


Version 1.15: (development snapshot)
------------------------------------

* Fixed bug under IRIX with endl output in --list-resources.
* Fixed bug with hidden files and recursive dirdiffs.
* Moved resourceParser to resParser.
* Fixed bugs with subprocess not being able to start, now getting error msg.
* Fixed line number resizing on text font change.
* Fixed [467697] bug with clipboard.
* Verified [463722] is fixed with the new parser.
* Ported directory reading to use QDir, which will port easily under Windows.
* Fixed bug [447051] with directory diffs.
* Added pangrams.
* Reorganized display dialog.
* Implemented font selection in display dialog.
* Insure that focus is on lineedit in search dialog [446125]
* Made sure that --list-resource redirected to file will be parsable [446109]
* Added FullScreen as a valid value for PrefGeometry resource [442547]
* fixed bug with dbg messages left in overview scrollbars code [456979]
* addressed issues: [442465], [441199], [441195], [462234]
* fixed bug with SHOW_TOOLBAR not being implemented [446123]
* fixed bug with setting the commands from options dialog.
* reviewed all FIXME comments, address all of the current changes
* reviewed all #if 0 blocks, address all
* fix for parser which could not  be restarted it seems
* removed app font override.  let them users use that old font if they
  want sgi looks.
* removed XLFD warning by changing to a different XLFD but that generates
  the same font.
* Re-implemented the generated init file functionality.
* remove singleton b.s. from resources.
* remove all the autoconf b.s. files in the root,
  change INSTALL file to my own install instructions, perhaps remove and
  point to README file.
* remove ifdefs for version 220, xxdiff now requires 2.3.x
  (sorry, it shouldn't be that hard to upgrade)
* added cheesy gif logo for about box for 2.0 rewrite
* fixed update bug with the options dialog.
* replaced accelUtil search with a sort + binary search op for speed.
  We still cannot use QAccel::stringToKey, it crashes, but it looks from the
  docs that Qt-3.0 will fix the problem.
* Finished new editing of colors and color legend.
* fixed color dialog choosing colors
* Lots of cleanup.
* New and improved color legend and editing: the legend is gone, and
  the user interface to set the colors now displays with the text font,
  as well as with the appropriate colors.
* fully removed dynamic 'manual'.  Manual will get compiled in.
* version is now in version.h
* removed old crap in resources.cpp
* worked on parser memory cleanliness
* move preferred_geometry to initgeometry or prefgeom
* removed all old autoconf-related files
* removed rcfileparser files.
* renamed XxRcfileParser to XxResourceParser
* Started moving to the new resources system.
* Finished full parser.
* Worked on parser, lots.
* Separated accelerator parsing into it's own compilation unit.
* Created new resource parser files.
* Removed unused line number background coloring code.
* Moved line color algorithm... in line class, where it belongs.
* Moved internal diff parser to Qt streams.
* Removed the XxStringResParser.
* Cleaned up some of the privately declared exceptions.
* eradicated std::string and standardized on QString, except for converting
  from an ostringstream.  we want only one type of string, and we can't
  really eradicate QString because we use Qt.  besides it's not that bad and
  all those string conversions are probably costing something.


Version 1.14: (development snapshot)
------------------------------------

* We're pretty much (almost) std::string-free at this point.
  I haven't addressed the many bug requests yet.
* Disabled buggy socket notification for editor subprocess.
* cleaned up all exceptions that takes strings:
  - unified code for taking strings in base class
  - all exceptions now takes special arguments
* Big QString unification takeover (over std::string):
  - removed using namespace std where not needed
  - reviewed all uses of c_str() and latin1()
  - grepped for std::string in all of code, make sure none remains
  - cleaned up some more strings business
  - removed all string.h where I could
  - ostream cleanup, use the Qt versions where you can do.
* fixed bug with clipboard text format widget
* removed as much std::string as was possible, moved all to QString
* Much more strings cleanup.
* Remove useless Xrm resources support.
* Removed silly configuration from configure.in.
  We use tmake now anyway.
* Removed runtime help option b.s.
* Fixed it under IRIX, made both diff and diff3 available.
* Managed to get linked GNU diff output and diffs under Linux, still
  broken under IRIX.
* More strings cleanup, not done yet.
* Finally linked together GNU diff and xxdiff, now working on supporting
  internal diffs without fork to external program.
* Fixed error msg on [442465]
* Removed throw new calls [463709]
* More work in no process hack.
* Simple hack for diffutils to link with xxdiff.
* Moved to tmake in preparation for Windows port.
  Tmake is simple and nice, although less portable.
  I always hated the autoconf/automake mess anyway.
  I'll move to Jam files eventually, that could be even nicer.
* More work for Windows port, what a pain in the butt it is.
* Just started Windows port using the non-commercial Qt for Windows.
  (2001-09-24 22:00:15 blais)

Version 1.13
------------

* Release.

* Change in parser, workaround for ":" in clipboard text string.
* Fixed bug with clipboard formatting on files that had %s in them
  (infinite loop).
* Generated and removed dependency on man.h.
* Fixed bug [430778]: renamed "open file" to "replace file".
* Fixed bug [437962]: no window class name, in all windows and dialogs.
* Started implementing overview area scrollbar, the offset is not file
  specific yet, the inverse mapping (file to display) has to be done.
* Autoconf-2.50 fixes under IRIX.
* Fixed logical bug in ignore horizontal whitespace.
  It should ignore much more now!
* Lots of spec file diddling.
* Bug fix: ignore file was displayed in 2-way diff mode.

Version 1.12
------------

* Release.

* Implemented options ui for ignore file feature.
* Fixed spec file for redhat compliance and succesfully sbumitted to
  rhcontrib.
* Finished implementing "ignore file" feature.
* More progress implementing ignore file, almost done.
* New feature: implemented ignore file (in 3-way diffs mode only).
* Fixed missing tab-at-3 ui update.
* New feature: remove file.
* Added rudimentary support in the code for making timings using gtod().
  Timings show that parsing resources is not a big problem under IRIX.
* Removed filename from clipboard text (not needed, usually annoying).
* Added "clipboard text format" format string to resources and
  infrastructure, and implemented format clipboard text.
* Renamed "cut-n-paste annotations" to "clipboard text formatted" because
  annotations are a different thing in cvs and clearcase.
* Fixed spec file (thx to Peder Stray peder@linpro.no).

Version 1.11
------------

* Release.

Version 1.10.1:

* Fixed small symbol rcfile parsing problem
  (added symbols for full font spec)
* Fixed --args with directory diffs (was not working).
* Implemented vertical line for characters-per-line.
* Applied OpenBSD security patches to strcpy/sprintf (thanks to Dan Weeks).
* Added vertical line resources only.
* Toggle line numbers and toggle show markers is now under 'display' menu.
  (bug #233520)
* Implemented 'remove empty conditionals' for save as w/ conditionals.
* Changed cpp conditionals default format.
* Fix for Mandrake compilation in configure.in (finding uic).

Version 1.10
------------

* Release.

Version 1.9.3
-------------

* Types cleanup (XxFln and XxDln and more).
* Implemented goto-line feature in search dialog.
* Implemented @@.* removal in "Save As" because ClearCase takes forever to
  come up with a directory that we don't care about anyway.  Save As when
  using ClearCase extended syntax should be fast now (untested).
* Started implementing goto-line feature (unfinished).
* Finished implementing copyFile feature.
* Bug fix in --list-resources.

Version 1.9.2
-------------

* added "-a" option for direct support when diff thinks of binary files
* added "--args" option to specify arbitrary arguments to diffs
* sets titlebar for 3 files
* now returns a nice error message when dir diff invoked with 3 files.
* added file copy feature for directory diffs (idea from
  Guillaume Kerrien, gkerrien@free.fr)
* enable state on view popup now makes sense
* started working on file copy idea, FIXME not done
* verified that when ignoring CR/LF, and then saving, it does not introduce
  lines? not a bug.

Version 1.9.1
-------------

* Fixed bug in --list-resources option, now prints all resources, regardless
  if they have a value or not.
* Fixes for OpenBSD and Debian ports.

Version 1.9
-----------

* Release.
  Recursive directory diffs and fix for broken 3-way diffs in 1.7.

Version 1.8.3
-------------

* Disable opening with no files.
* add URL to web page in about box.
* Changed Makefile not to use buggy automatic filenames (broken with automoc)
* Starting xxdiff without filenames is not possible anymore.
* Fixed -w and -b cmdline switches
* Fixed toggle options bug from menus
* Fixed options dialog bug.

Version 1.8.2
-------------

* release and ?

Version 1.8.1
-------------

* Started using CVS and ChangeLog actively, so releases now should contain
  more stuff in them.
* made errors dialog pop in front of main window, not behind
* separated suicide message box
* removed tabwidth dialog
* finished display options dialog.
* added display options in options dialog, and made switch
  automatically from menu invocation to correct tab
* fiddled with secondary merge window a bit. using qsplitter
  doesn't work well, so nix it.
* Horizontal scrollbar now hides when not necessary.
* made color selection dialog work.
* Separate merged view classes.
* Fixed usage message output of exception caught.
* implemented simple ifdef markers output. still have to become selective on
  this output (i.e. don't output empty regions).
* added new resources for text tags.
* Small changes in markers file dialog.
* removed warning about unselected regions when saving, use markers dialog
  instead.
* implemented file dialog with markers selection for unselected regions.
* brand new search dialog, muchos better than the last one.
* renamed _GCC to _GNU.
* changed the way the GNU compiler is recognized.
* resources.h: static methods to get res names.
* app.cpp: removed hardcoded resource names.

Version 1.8
-----------

* Release.
  Recursive directory diffs and fix for broken 3-way diffs in 1.7.

Version 1.7.6
-------------

* Fixed 3-way diffs that were broken between 1.6.9 and 1.6.12.
  (Will have to release again because of that.)
* Fixed bugs in new space-tidying function.
* Remove undef calls, so that XX_TRACE() works everywhere, replaced by
  uniform XX_LOCAL_TRACE() trick.
* Factored options dialog into three tabs, disabled 2-way options in 3-way
  mode.
* Removed old diff options dialog.
* Creating errors in editing options should display errors in dialog,
  cleaned up cerr output, now goes into dialog.

Version 1.7.5
-------------

* Bug fixes.
* More work on options dialog.
* Fixed recursive diff and build solely from output combination.
* Major review of resource names.
* United colors.
* Resource improvements, lots of important changes, user-visible
  consequences (resource names have changed).
* Added resources for GNU diff options (-r) (-i) etc

Version 1.7.4
-------------

* Some unfinished work on changing command lines.

Version 1.7.3
-------------

* Sped up resources compilation with a simple const.
* Completed UI menus changes.
* Fixed bug in dir diffs parsing.
* Added designer dialog for diff options, unfinished implementing.
* Added direcotry color in color legend.
* Removed forced italic font, we can just use the SGI style now.

Version 1.7.2
-------------

* Add recursive option to diff options menu.
* Hide files goes in dir diff options menu.
* Separate options that influence the diff command line and those that
  are only about display. ("diff options" menu vs. "display" menu)
* Move "redo diff" and "diff args" into new "options" menu.
* Move "hide CR" menu in new "display" menu.

Version 1.7.1
-------------

* In overview, coverage line is covering region properly now (it used to
  cover to the center of lines).
* Parsing of directory diffs is now done using solely the diff output, and
  not reading the directories themselves anymore.
* Fixes for recursive directory diffs. Recursive now works!!
* Added resources for supporting recursive and non-recursive dir diff.


Version 1.7
-----------

* Release.
  Directory diffs introduction warrants major number release but I'll
  release 2.0 when recursive directory diffs work. For work we'll let
  some people bang on it before 2.0.

Version 1.6.17
--------------

* Fixed compilation with g++ under Linux.

Version 1.6.16
--------------

* Added forgotten "common subdirectories" parsing to dir diffs parser.
* Fixed hunks in dir diffs.
* Fixed color documentation bug.
* Added "directories" line type and resources (colors).
* Fixed bug: running xxdiff with two empty files crashed it.
* In directory diffs, a lot of UI has been disabled (e.g. selection).
* Removed builderDirs2Sep from compilation.
* Changed the toolbar buttons for directory diffs.
* Add a toolbar button in dir diffs mode to diff files at cursor
* Added an option to hide changed files in directory diffs.

Version 1.6.15
--------------

* Finished first implementation of directory diffs using dir diff parser.

Version 1.6.14
--------------

* Added support for hiding carriage returns in diffs.

Version 1.6.13
--------------

* Finished directory diffs parser implementation.

Version 1.6.12
--------------

* Removed instantiation of std::vector<string> for size.
* More of implementing the directory diffs builder.

Version 1.6.11
--------------

* Factored some generic functionailty in XxUtil.
* Started parser directory diffs builder.

Version 1.6.10
--------------

* Factored some of the builders simple code into a base class.
* Started parser directory diffs builder using output of diff -q -s.
* Changed default configure options to compile rcfile resources by default.

Version 1.6.9
-------------

* Compiled with qt-2.2.
* Changed style to use new available SGI style in qt-2.2.
  It now has exactly the SGI looks!
* Incorporated changes by Bob Bell <bobbell@zk3.dec.com> for Tru64 port.

Version 1.6.8
-------------

* Cleanup of preliminary parser for directory diffs.
* Noticed that directory diffs are dead slow, tried to optimize using
  fork()/execve().  Had to provide envp from main().
* Implemented faulty mouse-drag on merged view.
* Added diffutils-2.7 source code to package in preparation to link with it
  directly. I think that this will make directory diffs faster.

Version 1.6.7
-------------

* diff3: When selecting a region whose text is the same as another,
  e.g. DELETE_1 selecting 2 or 3, show both of these as selected (even though
  the selection is allowed to vary between 2 or 3, we don't care).
* Renamed XxFile to XxBuffer in preparation for dir.diffs.
* Fixed bug with tooltip. Tooltip now works ok with truncation and resize.
* Implemented mouse-drag like in emacs on Ctrl+Button3.
* Fixed bug with copy label.
* Implemented preliminary directory diffs parsing.

Version 1.6.6
-------------

* Dist target was broken, put pixmaps back in and getopt.h

Version 1.6.5
-------------

* Fixed label resizing restriction.
* Implemented truncation [...] of pathname in filename label.a

Version 1.6.4
-------------

* Misc. UI changes.
* Removed forgotten tracing from diff3 builder.
* Ordered CHANGES file in reversed (makes more sense).

Version 1.6.3
-------------

* Fixed exit-on-same feature that was broken in 1.6.2 (hubert)
* Re-introduced support for xdiff's -N feature.

Version 1.6.2
-------------

* Modified to use GNU getopt_long().
* Removed -N option and implemented --titleX options instead.
* Implemented resource specification on cmdline (belley and J.Slade)
* New menu: windows.
* Implemented the toolbar and added lame pixmaps.
* Fixed "socket already in use" bug.

Version 1.6.1
-------------

* Fixed man page version and bug.
* Filename labels now show the full filenames as a tooltip if it doesn't fit
  in the label.


Version 1.6
-----------

* Release. Has been tested by many eng. at DL, quite stable.

Version 1.5.9
-------------

* Converted signal() to sigaction() for portability (caught by fjaubert).
* Fiddled makefiles to work under Solaris2.8.

Version 1.5.8
-------------

* Fixed bug in 3-way diff when diff at the very first line (thanks to
  Damjan Lango for reporting it).

Version 1.5.7
-------------

* Fixed Makefile problem with IRIX.
* Fixed doc distribution makefile problem.
* Fixed save as bug in 3-way (thanks to hubert for reporting it).

Version 1.5.6
-------------

* Added documentation which had mysteriously disappeared.

Version 1.5.5
-------------

* (don't remember what)

Version 1.5.4
-------------

* Added feature: ask user to save if the selections wouldn't save anything
  different (ask because it could be the case that the file has changed
  from some other program).
* Fixed majorly important issue: pressing Escape on a dialog did NOT cancel
  before (I can't believe I survived thru this since I always dismiss them
  like that).  Well, now it works as expected.

Version 1.5.3
-------------

* Fixed cursor centering bug (jaubert).

Version 1.5.2
-------------

* Wrote SGML documentation!

Version 1.5.1
-------------

* File renaming in preview of directory diff implementation.
* Noticed that "ignore whitespace" will not work with cleartool diff,
  fixed that with special case.
* Wrote tools/diffToClearCase wrapper script.
* Merged 1.4.6 -> 1.4.7 changes and this.

Version 1.5
-----------

* Release (lots of bug fixes).

Version 1.4.7
-------------

* Added horizontal-diffs-ignore-whitespace, which ignores whitespace
  differences when doing diffs horizontally (a separate process than
  the usual line-per-line diffs).  This feature is a little bit tricky:
  you cannot just skip the whitespace, to begin skipping, all the sides
  have to start with some whitespace.
* Fixed bug with horizontal diff: rendering tabs wasn't done correctly.
* Added resource to disable display of cursor (for mcguffm, jfr?).
* Fixed geometry parsing bug (ptrembla), result is still not perfect, need to
  communicate with winmgr to do it properly.  Qt doesn't offer support there?
* Fixed makefile linker for libstdc++ rt dependency.
* Fixed tabs rendering bug.

Version 1.4.6
-------------

* Fixed nasty bug in diff3 parser (due to funky clearcase reporting).
  Caught by belley, thank you!

Version 1.4.5
-------------

* Split/swap/merge renamed split/swap/join to avoid confusion with
  upcomin merge feature.
* Added merge feature.

Version 1.4.4
-------------

* Fixed bug on IRIX: \n doesn't show in --help output.
* Fixed "return value of 1" mistake introduced in 1.4.3.
* Better handling of errors.
* Added edit left/middle/right feature, accel resources + edit command
  resource.  Works with a signal handler waking up the event queue thru a
  socket.
* Now warns about ignore resource in rcfile.

Version 1.4.3
-------------

* rpm_build fix.
* urgent bugs: problem xxdiffrc (belley).  Specification of command
  resource is now more robust.  Merged command and command-args resources
  (simpler and nicer).
* changed resource: ignoreErrors is now false by default.

Version 1.4.2
-------------

* Geometry now includes position, Xt-style (i.e. WxH+L+T), for belley
  (this allows you to specify a full-screen xxdiff).  Caveat: there is
  some flickering on startup, because of Qt limitations: a resize first
  occurs, and then a move.
* Smaller font for filename labels.

Version 1.4.1
-------------

* Bug fix: find next unselected and prev unselected were broken.
* Bug fix: select global unselected wasn't working for first line.
* Added warn-about-unsaved option/resource for gijsbert.

Version 1.4
-----------

* Release (stable three-way diffs support).

Version 1.3.13
--------------

* CHANGES update.
* Added --list-resources option to list the supported resources and docs.
* Adding samples.xxdiffrc to bin release becomes unnecessary.
* Finished gen.init.file feature.  Not sure if I like it too much.
* Fixing split/swap/join for 3-way structures.
* Split/swap/join now gets rid of empty lines.

Version 1.3.12
--------------

* More work on gen.init.file.

Version 1.3.11
--------------

* Static documentation and correct checking.
* Expanded cursor 1 pixel up and down for jfr.

Version 1.3.10
--------------

* Added resource documentation generating capabilities.

Version 1.3.9
-------------

* Added default bindings Ctrl+R -> Redo Diff for giasson.
* Fixed buffer allocation bug for string rendering which broke on long lines.
* Bug fix: horizontal scrollbar is not correct because of varying widths of
  text widgets due to linenumbers.  adjustScrollbars() cannot deal with it
  correctly since it gets called to adjust on the first widget's resize and
  the other ones haven't been resized yet (at that point).  We need to make
  the line numbers widget all the same size, but for that the lineNumbers
  format string has to be the same for all.
  (fixed).
* Fixed bottom filling region drawing minor bug.

Version 1.3.8
-------------

* New ideas in CHANGES.
* Fixed bug with empty files (for belley).

Version 1.3.7
-------------

* Fixed Linux compilation.
* Added "middle" commands.
* Fixed bug with file open and horizontal diffs.

Version 1.3.6
-------------

* Fixed IRIX compilation, lexer bug to parse "/".
* Two scrollbars for 3-way diff.
* Fixed "next difference" bug.

Version 1.3.5
-------------

* Three-way diffs now work!

Version 1.3.4
-------------

* Lots of work towards 3-way, almost there.

Version 1.3.3
-------------

* More unfinished work on 3-way diffs.

Version 1.3.2
-------------

* Figured out 3-way diff minimum set.

Version 1.3.1
-------------

* New ideas in CHANGES file.
* Started working on diff3 support.
* (this unstable version will not compile)

Version 1.3
-----------

* Release.

Version 1.2.15
--------------

* Fixed 1.2.14-introduced bug with redo diff on empty xxdiff.
* Made sure foreground color works: fixed bug, it wasn't working.
* Simplified getting files to other objects.

Version 1.2.14
--------------

* Updated README.
* Stripped down man page.
* Documentation web page: explain use patterns: merging, leaving regions
  unselected for further editing, short-lived diff (an assumption),
  emacs bindings.
* Bug fix: crashes when specifying only one file!
* Finished saving unselected anyway with tagging.
* Fixed global selection bug.
* Added all new colors to color legend, improved code a bit.
* Made the resources object a singleton everywhere in the code.
* Bug fix: isAsciiText doesn't deal with C-l's (which occurs often in text),
  make it work as ascii.  Now we're only checking the very first line of
  text.
* Added diff option toggles and resources and qualities.
* Bug fix: redo diff twice doesn't reappear (bug under IRIX only)

Version 1.2.13
--------------

* Fixed Linux compilation.
* Misc. changes.
* Wrote web documentation.

Version 1.2.12
--------------

* Finished merged view (pretty much).  Added cursor drawing, scroll
  tracking and proper resizing.

Version 1.2.11
--------------

* Comments.

Version 1.2.10
--------------

* Added a color for unmerged hunk text in merged view.

Version 1.2.9
-------------

* Made line numbers same width for single hor.scrollbar.
* Even more fiddling with the merged widget, almost done
  (still have to fix the vscroll)

Version 1.2.8
-------------

* More fiddling with the merged widget.

Version 1.2.7
-------------

* Added menu accelerators.
* Fixed toggle button bug.
* Added "select X and go to next unselected, wrap around if at the end of
  the file and save if no more unselected" (more simply called "select X and
  next").  This feature for rapid merging (request by Peter Maly and
  jdilelle).
* Started sketching out merged view.

Version 1.2.6
-------------

* Line numbers in their own widget.
* Bug fix: tabs weren't shifted correctly when showing line numbers
  (-> implement widget)
* Added a resource for preferred default geometry (for George Zamba)
* Cleaned up boolean resource access.
* Added a resource and UI for toggling markers (but no functionality)
* Bug fix: tabs and horizontal diffs weren't rendered synchronously.

Version 1.2.5
-------------

* Fixed bug in reading accelerators, made nicer.
* Added some more inline help.
* If a file is non-existent, now writes which file on stderr (for gijsbert).

Version 1.2.4
-------------

* Added comments to CHANGES.
* Wrote proper accelerator reading routine, home/end and func keys now work
  (fixes bug: Shift+F1 help doesn't work on on context menu).
* Clicking on the filename label puts the filename in the clipboard (this is
  a cool feature for making merge review comments with long ClearCase
  filenames).

Version 1.2.3
-------------

* Added reported bug to this file, reorganized this file.

Version 1.2.2
-------------

* Bug fix: when file is not writable, (e.g. clearcase not checked out) error
  was not reported (reported by gdh).
* Bug fix: redo diff was broken.  Change one of the files, then redo diff,
  it crapped out (reported by belley).
* Moved dialogs in their own compilation unit.
* Provided simple command to perform redo diff without asking for options
  (requested by belley)
* Started sketching out on-context help.

Version 1.2.1
-------------

* Fixed bug with lots of tabs in long lines.


Version 1.2
-----------

* Release.

Version 1.1.7
-------------

* comments added to CHANGES file.

Version 1.1.6
-------------

* important bug fixed: core dumps on options with whitespace in them.
* added exitOnSame option thru resource.

Version 1.1.5
-------------

* Fixed minimum size limitation on filenames.  ClearCase pnames tended to
  present a limitation on the horizontal size.

Version 1.1.4
-------------

* Fixed IRIX compilation.

Version 1.1.3
-------------

* Finished rc file support.
* Fixed horrible horizontal scrolling bug introduced in 1.1.
* Added accelerators for horizontal scrollbar.
* Fixed bug drawing horizontal cursor with hor.scroll bar to the right.
* Added simple dialog for setting tabs at arbitrary values.
* Moved compile options into configure script interfaces:

  - optimized vs. debug
  - dynamic vs. static linking for STLport and Qt

* Better autoconf/automake support.

Version 1.1.2
-------------

* Unfinished rc file support (~/.xxdiffrc or XXDIFFRC env var).
* Fixed bug with opening with no files.

Version 1.1.1
-------------

* Fixed bug: initially setting horizontal diff thru resource wasn't working.
* Added lighter colors for selected and deleted (looks much nicer in
  horizontal diffs more).
* Added "paste with line numbers" option, which add the name of the file as
  well as line numbers, this will be great for making review comments.



Version 1.1
-----------

* Release.

Version 1.0.7
-------------

* Horizontal diffs are calculated and displayed.  It rocks!
* Toggle menus are now displayed/updated correctly.

Version 1.0.6
-------------

* Now supports any length of line.
* Cleaner way to do search (no visible changes)
* Faster tabs rendering, correct computation of line length with tabs which
  affected horizontal scrollbar.
* Silenced the raw font warning in optimized mode.

Version 1.0.5
-------------

* Ported to STLport.
* Static linkage for better Linux distribution.
* Fixed a bug when vertical maximizing the overview: didn't redraw
  visible regions correctly.

Version 1.0.4
-------------

* Man page is now generated and compiled inline by default.
* I'm so sloppy, tabs other than 8 were still broken.
  Hopefully this is finally fixed.
* Fixed a bug in the search feature.

Version 1.0.3
-------------

* Parsing command line for three-way and directory diffs has been done.
* Fixed important tabs bug (1.0.2 fix was botched).
* Supports empty files.
* Updated man page.
* Redo diff is now a dialog that allows to change the command.

Version 1.0.2
-------------

* Fixed important tabs bug.
* Added display of visible region in overview area.
* Removed senseless "global unselected unselect" command.
* Moved strstream's to stringstream's.
* Added new color for changed regions which have text.

Version 1.0.1
-------------

* Removed no background X11 hack.
* Some fixes to get compiling under MIPSpro 7.3.1.1m compiler.


Version 1.0
-----------

* First public release, features match xdiff 1.0.



KNOWN BUGS
==========

* Using diff option "-B" with xxdiff doesn't work for now.
